#--------------------------------------------------------------#
#
# Set Board pinout
#
load_package project
load_package report
load_package flow
load_package incremental_compilation
load_package partial_reconfiguration


if { $argc != 3} {
   puts "Error: ********************************************************************************************"
   puts "  qii_create_cvp_partition_revision.tcl requires three inputs  "
   puts "  Usage:                                                                                           "
   puts "  quartus_sh -t qii_create_cvp_partition_revision.tcl <project>  <partition_name> <revision_name>  "
   puts "     <project>      : Quartus II project name  - required                                          "
   puts "     <partition>    : Quartus II partition name - required                                         "
   puts "     <revision>     : Quartus II revision name  - required                                         "
   puts "Error: ********************************************************************************************"
   return 1
} 

set project_name  [lindex $quartus(args) 0]
set partition_name [lindex $quartus(args) 1]
set revision_name [lindex $quartus(args) 2]

puts "Info: *******************************************************************************"
puts "Info  Create CvP Design Partition $partition_name under $project_name:$partition_name"
#puts "Info  Create CvP Revision $revition_name  under $project_name                        "
puts "Info  Create CvP Revision cvp_app under $project_name                        "
puts "Info: *******************************************************************************"
   

#--------------------------------------------------------------#
#
# Open Quartus II project
#
if { [ project_exists $project_name ]  } {
   project_open $project_name -force
} else {
   puts "Error: *******************************************************************"
   puts "   Error:  Unable to open Quartus II project $project_name"
   puts $fileId "   Error:  Unable to open Quartus II project $project_name"
   close $fileId
   return 1
}

#--------------------------------------------------------------#
# Base revision
  set_current_revision -force $project_name
  puts "Set_current_revision to $project_name"

# 1. Set Design partition and on user_led and set_partition_type = Source_file and Allow_Multiple_Persona=ON
# Assuming that the entity name is the same as the $partition_name in the design
create_partition -partition $partition_name -content $partition_name:$partition_name;
set_partition -partition $partition_name -netlist_type "Source File" -allow_multiple_personas "ON";

# 2. Create CvP revision 
create_pr_revision  -based_on $project_name  -cvp $revision_name;

#--------------------------------------------------------------#
# Start set up CvP revision
# 3). Add new verilog cvp_app_src/user_led.v to cvp_app.qsf
# 4)  Set_netlist_type of user_led partition to be "Source File" 

  set_current_revision -force $revision_name
  puts "Set_current_revision to $revision_name"
  set_global_assignment -name VERILOG_FILE cvp_app_src/user_led.v
  set_partition -partition $partition_name -netlist_type "Source File" -allow_multiple_personas "ON";

########################
project_close
return 0
